/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.importer;

import java.util.List;

import org.dive4elements.river.importer.common.StoreMode;
import org.dive4elements.river.model.River;
import org.dive4elements.river.model.WstColumn;
import org.dive4elements.river.model.WstColumnQRange;
import org.dive4elements.river.model.WstQRange;
import org.hibernate.Query;
import org.hibernate.Session;

public class ImportWstColumnQRange
{
    protected ImportWstColumn wstColumn;
    protected ImportWstQRange qRange;

    protected StoreMode storeMode;

    protected WstColumnQRange peer;

    public ImportWstColumnQRange() {
    }

    public ImportWstColumnQRange(
            final ImportWstColumn wstColumn,
            final ImportWstQRange qRange
            ) {
        this.wstColumn = wstColumn;
        this.qRange    = qRange;
        this.storeMode = StoreMode.NONE;
    }

    public ImportWstColumn getWstColumn() {
        return this.wstColumn;
    }

    public void setWstColumn(final ImportWstColumn wstColumn) {
        this.wstColumn = wstColumn;
    }

    public ImportWstQRange getQRange() {
        return this.qRange;
    }

    public void setQRange(final ImportWstQRange qRange) {
        this.qRange = qRange;
    }

    public WstColumnQRange getPeer(final River river) {
        if (this.peer == null) {
            final WstColumn c = this.wstColumn.getPeer(river);
            final WstQRange q = this.qRange.getPeer(river);
            List<WstColumnQRange> cols;
            final Session session = ImporterSession.getInstance()
                    .getDatabaseSession();
            if (this.wstColumn.storeMode == StoreMode.INSERT)
                cols = null;
            else {
                final Query query = session.createQuery(
                        "from WstColumnQRange where " +
                        "wstColumn=:c and wstQRange=:q");
                query.setParameter("c", c);
                query.setParameter("q", q);
                cols = query.list();
            }
            if ((cols == null) || cols.isEmpty()) {
                this.peer = new WstColumnQRange(c, q);
                session.save(this.peer);
                this.storeMode = StoreMode.INSERT;
            }
            else {
                this.peer = cols.get(0);
                this.storeMode = StoreMode.UPDATE;
            }
        }
        return this.peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
